/*global $, jQuery, console*/
$(document).ready(function () {
    "use strict";
    var nav = $('#menu').find('a'), //prepare nav links array
        
        //initialize bxslider
        slider = $('#pages').bxSlider({
            pager: false,
            speed: 1000,
            controls: false,
            onSlideBefore: function ($el, oldIndex, newIndex) { //switches current page link highlight
                if (oldIndex !== 0) {nav.eq(oldIndex - 1).parent().removeClass('current'); }
                if (newIndex !== 0) {nav.eq(newIndex - 1).parent().addClass('current'); }

                // index - 1 is required because there's an empty first slide, that has no menu link
            }
        }),
        
        goto = function(index) {
            if (nav.length <= index || index < 0) {
                return false;
            }
            slider.goToSlide(index);
        },
        
        //finds slide based on given slug
        jump = function (slug) {
            if (slug === undefined) {return; }
            nav.each(function (i) {//cycle through menu
                if ($(this).parent().prop('class').toLowerCase().indexOf(slug.toLowerCase()) >= 0) { //li.class contains slug
                    slider.goToSlide(i + 1);
                    return false; //same as break
                }
            });
        },
        
        //splitted site url to detect local links
        site_url = window.location.href.replace('#', '').split(new RegExp("//|/|=")).filter(function (e) {return e; });
        //end of variables declaration

    //initialization
    nav.eq(0).parent().removeClass('current');
    nav.each(function (i) {
        $(this).prop("href", "#"); //remove all links (VERY important!)
        $(this).click(function () {
            slider.goToSlide(i + 1);

            //collapse mobile menu on click (touch) event
            if ($('#mobile-menu').css("visibility") === "visible") {$('#nav ul').toggle();}
            
        });
    });

    String.prototype.endsWith = function(str) {return (this.match(str+"$")==str)}
    
    $('.page-wrapper').each(function (i) {
        $(this).find('a').each(function () {
            var a = $(this),
                link_url;
            if (a.hasClass('slider-next') || a.hasClass('slider-prev') || a.hasClass('slider-jump')) {
                return false; //manually created links
            }
            if (a.prop('href').endsWith('jpg') || a.prop('href').endsWith('gif') || a.prop('href').endsWith('png')) {
                return false; //image link
            }            
            link_url = a.prop('href').replace('#', '').split(new RegExp("//|/|=|#")).filter(function (e) {return e; });
            for (var el = 0; el < link_url.length; el++) {
                if (el >= site_url.length) {
                    a.prop('href', '#').addClass('slider-jump').attr('data-jump', link_url[link_url.length - 1]);
                    break;
                } else if (link_url[el] !== site_url[el]) {
                    break;
                }
            }
        });
        
        
    });
    
    //helper classes for site-wide links
    $('.slider-next').prop('href', '#').click(function () {slider.goToNextSlide(); });
    $('.slider-prev').prop('href', '#').click(function () {slider.goToPrevSlide(); });
    $('.slider-jump').prop('href', '#').click(function () {jump($(this).attr('data-jump')); }); //data-jump should be page slug
    $('.slider-goto').prop('href', '#').click(function () {goto($(this).attr('data-goto')); }); //number of the slide to jump
        
    $('#logo a').prop('href', '#').click(function () {slider.goToSlide(0); }); //logo link points to first (empty) slide
    
    $('#mobile-menu').click(function () {$('#nav ul').toggle();});
});